import java.io.*;
import java.util.*;
import java.util.jar.*;

class Main {
    public static void main(String[] args) {
        if (args.length < 1) {
            System.err.println("Usage: java Main <jar-file> [entry-name]");
            System.exit(1);
        } 

	try {
	    JarFile jf = new JarFile(args[0], true);
            String entryName = JarFile.MANIFEST_NAME;
    
            if (args.length >= 2) {
                entryName = args[1];
            } else if (args.length >= 1) {
	        if (jf.getManifest() == null) {
		    System.err.println("No manifest in this JAR file.");
		    System.exit(1);
	        } 
            } 

	    JarEntry je = jf.getJarEntry(entryName);

            if (je == null) {
                System.err.println("No such entry.");

                // List the names of all entries in the jar file.
                for (Enumeration e=jf.entries(); e.hasMoreElements(); ) {
	            System.out.println("  "+e.nextElement());
                }
                System.exit(1);
            }
                
            InputStream is = jf.getInputStream(je);
            int len;

            // Dump the jar entry data to standard output.
            byte[] buf = new byte[(int)je.getSize()];
            is.read(buf);
	    System.out.write(buf);
            is.close();
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }
}
