import java.io.*;

class Main {
    public static void main(String[] args) {
        if (args.length != 2) {
            System.err.println("usage: java Main <directory> <suffix>");
            System.exit(-1);
        }

        File dir = new File(args[0]);
        File[] fs = dir.listFiles(new SuffixFileFilter(args[1]));
        if (dir == null) {
            System.out.println(args[0] + " is not a directory");
        } else {
            for (int i = 0; i < fs.length; i++) {
                System.out.println(fs[i]);
            }
        }
    }

    static class SuffixFileFilter implements FileFilter {
        String suffix;
        SuffixFileFilter(String suffix) {
            this.suffix = suffix;
        }

        public boolean accept(File target) {
            return target.getName().endsWith(suffix);
        }
    }
}
