import java.io.*;
import java.util.*;
import java.util.zip.*;

class FileWalker extends Observable {
    void walk(File dir, boolean includeDirectories, FileFilter filter) {
        if (dir.isDirectory()) {
            if (includeDirectories) {
                setChanged();
                notifyObservers(dir);
            }
            File[] files = dir.listFiles(filter);

            if (files != null) {
                for (int i=0; i<files.length; i++) {
                    walk(files[i], includeDirectories, filter);
                }
            }
        } else {
            setChanged();
            notifyObservers(dir);
        }
    }
}
