import java.io.*;
import java.security.PermissionCollection;

public class Main {
    public static void main(String[] args) {
//
        char s = File.separatorChar;
        FilePermission[] p = new FilePermission[5];

        // Allow entire /tmp subtree to be read, including its root
        p[0] = new FilePermission(s+"tmp"+s+"-", "read");
        p[1] = new FilePermission(s+"tmp", "read");

        // Allow writes to /tmp/myapp directory
        p[2] = new FilePermission(s+"tmp"+s+"myapp", "write");
        p[3] = new FilePermission(s+"tmp"+s+"myapp"+s+"*", "write");

        // Allow execution in /tmp/myapp/bin/*
        p[4] = new FilePermission(s+"tmp"+s+"myapp"+s+"bin"+s+"*", "execute");

        PermissionCollection col = p[0].newPermissionCollection();
        for (int i = 0; i < p.length; i++) {
            col.add(p[i]);
        }

        // OK to write to /tmp/myapp/bin?
        System.out.println(col.implies(
            new FilePermission(s+"tmp"+s+"myapp"+s+"bin", "write"))); 
                                                                // true

        // OK to read/execute /tmp/myapp/bin/install?
        System.out.println(col.implies(
            new FilePermission(s+"tmp"+s+"myapp"+s+"bin"+s+"install", 
                "read, execute")));
                                                                // true

        // OK to read/write to /tmp/myapp/bin/install?
        System.out.println(col.implies(
            new FilePermission(s+"tmp"+s+"myapp"+s+"bin"+s+"install", 
                "read, write")));
                                                                // false
//
    }
}


    
