import java.io.*;
import java.awt.Button;

public class ClassA implements Serializable {
    /**
     * A string field.
     * @serial
     */
    String strField;

    /**
     * An int field.
     * @serial
     */
    int intField;

    /**
     * A byte array field.
     * @serial
     */
    byte[] byteArrayField = new byte[] {(byte)3, (byte)2, (byte)1};

    /**
     * An object field.
     * @serial
     */
    Button[] buttons  = new Button[] {new Button("push me")};

    public ClassA(String one, int two) {
        strField = one;
        intField = two;
    }
    private void readObject(ObjectInputStream in) 
        throws IOException, ClassNotFoundException {

            // Read in serial fields
            ObjectInputStream.GetField pfields = in.readFields();

            // Assign serialized values to fields
            strField = (String)pfields.get("strField", "out-of-luck");
            intField = (int)pfields.get("intField", 1000);
            byteArrayField = (byte[]) pfields.get("byteArrayField", null);
            buttons = (Button[]) pfields.get("buttons", null);

            // Get ObjectStreamClass to get ObjectStreamFields for each field
            ObjectStreamClass objclass = pfields.getObjectStreamClass();
            print("strField", objclass.getField("strField"));
            print("intField", objclass.getField("intField"));
            print("byteArrayField", objclass.getField("byteArrayField"));
            print("buttons", objclass.getField("buttons"));
            print("notThere", objclass.getField("notThere")); // null
    }
    private void print(String field, ObjectStreamField fd) {
        System.out.println("Field: " + field);
        if (fd != null) {
            System.out.println("name: " + fd.getName());
            System.out.println("type: " + fd.getType());
            System.out.println("type code: " + fd.getTypeCode());
            System.out.println("type string: " + fd.getTypeString());
            System.out.println("primitive: " + fd.isPrimitive());
            System.out.println("offset: " + fd.getOffset());
        }
    }
    public String toString() {
        return "strField: " + strField +
            " intField: " + intField +
            " byteArrayField: " + byteArrayField +
            " buttons: " + buttons;
    }
}
