import java.net.*;
import java.io.*;

class Main {
    public static void main(String[] args) {
        if (args.length != 3) {
            System.err.println(
                "usage: java Main <dir> <classname> <resource>");
            System.exit(-1);
        }
        
        try {
            ClassLoader cl = new FlatClassLoader(args[0]);

            // See who cl's parent is
            System.out.println("Parent: " + cl.getParent());

            // Load a class
            Class c = cl.loadClass(args[1]);
            
            System.out.println("Class: " + c);
            System.out.println("Package: " + c.getPackage());
            System.out.println("Resource: " + cl.getResource(args[2]));
            System.out.println("Resource Stream: " + 
                cl.getResourceAsStream(args[2]));

        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
    }
}
