class Main {
    static InheritableThreadLocal thrloc = new InheritableThreadLocal() {
        public Object initialValue() {
            System.out.println("iv");                    // 1: "iv"
            return "MainThread";
        }
        public Object childValue(Object parentVal) {
            System.out.println("cv " + thrloc.get());    // 3: "cv MainThread"
            return parentVal + "-2";
        }
    };

    Main() {
        System.out.println(thrloc.get());                // 2: "MainThread"
        Thread t = new MyThread(1);
        t.start();
        try {
            t.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        System.out.println(thrloc.get());                // 9: "MainThread"
    }

    public static void main(String[] args) {
        new Main();
    }
}

class MyThread extends Thread {
    private int val;
    public MyThread(int val) {
        System.out.println("c " + Main.thrloc.get());    // 4: "c MainThread"
        this.val = val;
    }
    public void run() {
        System.out.println(Main.thrloc.get());           // 5: "MainThread-2"
        Main.thrloc.set("Thread" + val);
        System.out.println(Main.thrloc.get());           // 6: "Thread1"

        if (val == 1) {
            new MyThread(2).start();
                                                // Output from 2nd thread:
                                                         // 7:  "cv Thread1"
                                                         // 8:  "c Thread1"
                                                         // 10: "Thread1-2"
                                                         // 11: "Thread2"
        }
    }
}
