class Main {
    static InheritableThreadLocal thdloc = new InheritableThreadLocal();

    Main() {
        print();                                // 1: "null"
        thdloc.set("MainThread");
        print();                                // 3: "MainThread"

        Thread t = new MyThread(this);

        // Change the variable to see if the child thread
        // inherits the value before or after it is constructed.
        thdloc.set("MainThread-2");

        t.start();
        try {
            t.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        print();                                // 6: "MainThread-2"
    }

    public void print() {
        System.out.println(thdloc.get());
    }

    public static void main(String[] args) {
        new Main();
    }
}

class MyThread extends Thread {
    Main main;

    MyThread(Main main) {
        this.main = main;
        main.print();                           // 2: "MainThread"

        // Executing in the wrong thread for setting the thread local variable.
        // Main.thdloc.set("MyThread");
    }
    public void run() {
        main.print();                           // 4: "MainThread"
        Main.thdloc.set("MyThread");
        main.print();                           // 5: "MyThread"
    }
}
