class Main {
    static ThreadLocal thdloc = new ThreadLocal();

    Main() {
        print();                                // 1: "null"
        thdloc.set("MainThread");
        print();                                // 2: "MainThread"

        Thread t = new MyThread(this);
        t.start();
        try {
            t.join();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        print();                                // 6: "MainThread"
    }

    public void print() {
        System.out.println(thdloc.get());
    }

    public static void main(String[] args) {
        new Main();
    }
}

class MyThread extends Thread {
    Main main;

    MyThread(Main main) {
        this.main = main;
        main.print();                           // 3: "MainThread"

        // Executes in the wrong thread for setting the thread local variable.
        // Main.thdloc.set("MyThread");
    }
    public void run() {
        main.print();                           // 4: "null"
        Main.thdloc.set("MyThread");
        main.print();                           // 5: "MyThread"
    }
}
