import java.util.*;

class Main {
    public static void main(String[] args) {
        Cell c = new ReadWriteCell("dog");
        c.set("cat");
        c = new ReadOnlyCell("dog");
        c.set("cat");        // UnsupportedOperationException
    }
}

interface Cell {
    Object get();
    void set(Object o);
}

class ReadOnlyCell implements Cell {
    Object cell;
    ReadOnlyCell(Object o) {
        cell = o;
    }
    public Object get() {
        return cell;
    }
    public void set(Object o) {
        throw new UnsupportedOperationException();
    }
}
class ReadWriteCell implements Cell {
    Object cell;
    ReadWriteCell(Object o) {
        cell = o;
    }
    public Object get() {
        return cell;
    }
    public void set(Object o) {
        cell = o;
    }
}

