import java.net.*;
import java.awt.*;
import java.awt.event.*;

public class Main extends Frame implements ActionListener {
    Main() {
        super("Authenticator Example");

        Button b = new Button("Login");
        b.addActionListener(this);
        add(b, BorderLayout.NORTH);

        pack();
        show();
    }

    public void actionPerformed(ActionEvent evt) {
        // Try to get authentication information
        try {
            PasswordAuthentication pw = 
                Authenticator.requestPasswordAuthentication(
                InetAddress.getLocalHost(), 
                555,    // port
                "foo",  // protocol
                null,   // prompt
                "cleartext");

            if (pw != null) {
                System.out.println("username: " + pw.getUserName());
                System.out.println("password: " + new String(pw.getPassword()));
            } else {
                System.out.println("No password entered");
            }
        } catch (UnknownHostException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        // Install authenticator
        Authenticator.setDefault(new SomeAuthenticator(new Main()));
    }
}
