import java.text.CollationElementIterator;
import java.text.Collator;
import java.text.RuleBasedCollator;
import java.util.Locale;

public class Main {
    public static void main(String[] args) {
        Locale loc = Locale.FRENCH;
        int element;

        // Set up string to iterate over.
        String str = "abcABC";

        // Create an instance of a subclass of collator.
        Collator collator = Collator.getInstance(loc);

        if (collator instanceof RuleBasedCollator) {
            // Cast to the subclass.
            RuleBasedCollator rbc = (RuleBasedCollator)collator;

            // Get the collation element of the string.
            CollationElementIterator cei = 
                rbc.getCollationElementIterator(str);

            // Set the text. Set offset to the end of the string.
            cei.setText(str);
            cei.setOffset(str.length());
            System.out.println(str);               // abcABC

            while ((element = cei.previous()) != 
                    CollationElementIterator.NULLORDER) {
                System.out.print(cei.getOffset());
            }                                      // 7766543210
            System.out.println("");
        }
    }
}
