import java.util.*;

class Main {
    public static void main(String[] args) {
        Hashtable h = new Hashtable();
        h.put("dog", "spot");
        h.put("cat", "luck");
        h.put("cow", "spot");
        h.put("yak", "spot");

        Collection col = h.values();
        printCol( col );                     // [luck, spot, spot, spot, ]
        System.out.println( col.contains("spot") );  // true

        // remove() removes one entry from the h.
        col.remove("spot");
        System.out.println( h );             // {cat=luck, cow=spot, yak=spot}
 
        // removeAll() removes all entries with the value "spot".
        col.removeAll(Collections.singleton("spot"));
        System.out.println( h );             // {cat=luck}

        // Add to the h and check the collection
        h.put("dog", "spot");
        printCol( col );                     // [luck, spot, ]

        // You can't add to the collection.
        //col.add("bess");                   // UnsupportedOperationException
    }

    static void printCol(Collection c) {
        System.out.print("[");
        for (Iterator it=c.iterator(); it.hasNext(); ) {
            System.out.print(it.next()+", ");
        }
        System.out.println("]");
    }
}
