import java.util.*;

class Main {
    public static void main(String[] args) {
        LinkedList list = new LinkedList();

        // Create and start up the producer and consumer threads.
        new Producer(list).start();
        new Consumer(list).start();
        new Consumer(list).start();
    }
}

class Consumer extends Thread {
    LinkedList list;
    Consumer(LinkedList l) {
        list = l;
    }

    public void run() {
        try {
            while (true) {
                synchronized (list) {
                    // Wait until not empty.
                    while (list.isEmpty()) {
                        list.wait();
                    }

                    // Remove and print the head of the queue.
                    System.out.println( this+": "+list.removeFirst() );
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

class Producer extends Thread {
    Random rnd = new Random();

    LinkedList list;
    Producer(LinkedList l) {
        list = l;
    }

    public void run() {
        int count = 0;
        try {
            while (true) {
                Thread.sleep(rnd.nextInt(2000));

                // Add an element to the end of the queue.
                synchronized (list) {
                    list.addLast(new Integer(count++));
                    list.notify();
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
