import java.math.*;
import java.util.*;

class Main {
    public static void main(String[] args) {
//
        // Two time zones with same raw offset but different daylight time.
        TimeZone tz1 = TimeZone.getTimeZone("MST");
        TimeZone tz2 = TimeZone.getTimeZone("America/Phoenix");
        System.out.println( tz1.getRawOffset()==tz2.getRawOffset() ); // true
        System.out.println( tz1.hasSameRules(tz2) );                  // false
        
        // Two time zones with same raw offset and daylight time but different ID.
        tz1 = TimeZone.getTimeZone("America/Vancouver");
        tz2 = TimeZone.getTimeZone("PST");
        System.out.println( tz1.hasSameRules(tz2) );                  // true

        // Two time zones with same and daylight time but different raw offset.
        tz2 = TimeZone.getTimeZone("MST");
        System.out.println( tz1.hasSameRules(tz2) );                  // false
//
    }
}
